// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <cstddef>
#include <iostream>
#include <string>

namespace Azure::Device::CrashHandler {

struct CrashParameters
{
    pid_t Pid = 0;
    pid_t ThreadId = 0;
    uint64_t Signal = 0;
    std::string FullPath;
    uint64_t TimestampSeconds = 0;
    bool CollectMetdataOnly = false;

    friend std::ostream&
    operator<<(std::ostream& os, const CrashParameters& params)
    {
        os << "[CrashParameters]" << std::endl;
        os << "Pid: " << params.Pid << std::endl;
        os << "ThreadId: " << params.ThreadId << std::endl;
        os << "Signal: " << params.Signal << std::endl;
        os << "FullPath: " << params.FullPath << std::endl;
        os << "Timestamp: " << params.TimestampSeconds << std::endl;
        os << "CollectMetdataOnly: " << params.CollectMetdataOnly << std::endl;
        return os;
    }
};
}
