// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <string>
#include <vector>

#include <nonstd/span.hpp>

#include "ElfArchitectureSpecifics.h"

namespace Azure::Device::CrashHandler {

struct MappedRegion
{
    size_t LowAddress = 0;
    size_t HighAddress = 0;
    std::string ModulePath;
};

struct ElfNotesContents
{
    std::vector<elf_prstatus> ThreadStates;
    std::vector<MappedRegion> MappedRegions;
};

ElfNotesContents
ParseElfNotes(nonstd::span<const std::byte> notesBytes, std::ostream& metaFile);
}
