// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <atomic>
#include <filesystem>
#include <string>
#include <thread>

#include <azure-device-errorreporting-submitter/ReportQueue.h>

namespace Azure { namespace Device { namespace ErrorReporting {
namespace Uploader {

class KernelDumpProcessor
{
  public:
    void ProcessDirectory(
        Azure::Device::ErrorReporting::Submitter::ReportQueue& reportQueue,
        std::string_view kernelDumpDirectory) noexcept;

  private:
    static uint64_t SubmitKernelDumpReport(
        Azure::Device::ErrorReporting::Submitter::ReportQueue& queue,
        const std::filesystem::path& dumpInstanceDirectory);
};

}}}}
