// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <atomic>
#include <string>
#include <vector>

namespace Azure { namespace Device { namespace ErrorReporting {
namespace Uploader {

struct UploadConfig
{
    std::string DeviceId;
    uint32_t SampleNumber = 0;
    std::string Proxy;
    bool DisableCertificateValidation = false;
    time_t UploadPollIntervalSeconds =
        INotifyMonitor::k_defaultPollIntervalSeconds;
};

class UploadConfigManager
{
  public:
    UploadConfig GetUploadConfig();

  private:
    void ReadUploadConfig(UploadConfig& config);
    void WriteUploadConfig(UploadConfig& config);
};

}}}}
