// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

// Declarations for inquiring about network interfaces
// This order is required to workaround double-include bugs in these headers

// clang-format off
#include <net/if.h>
#include <linux/wireless.h>
// clang-format on

namespace Azure { namespace Device { namespace Health {

class IOsSystemCallFacade
{
  public:
    virtual ~IOsSystemCallFacade() {}
    virtual int os_ioctl(int fd, unsigned long request, ifreq* freq) const = 0;
    virtual int os_ioctl(int fd, unsigned long request, iwreq* req) const = 0;
    virtual int
    os_ioctl(int fd, unsigned long request, const char* str) const = 0;
};

}}}
