// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include "IOsSystemCallFacade.h"
// Symbolic Constants
#include <unistd.h>

// Declarations for inquiring about network interfaces
#include <net/if.h>

// System & other networking headers
#include <linux/ethtool.h>
#include <linux/sockios.h>
#include <linux/wireless.h>
#include <sys/ioctl.h>
#include <sys/socket.h>

namespace Azure { namespace Device { namespace Health {

class OsSystemCall : public IOsSystemCallFacade
{
  public:
    int os_ioctl(int fd, unsigned long request, ifreq* freq) const override
    {
        return ioctl(fd, request, freq);
    }

    int os_ioctl(int fd, unsigned long request, iwreq* req) const override
    {
        return ioctl(fd, request, req);
    }

    int os_ioctl(int fd, unsigned long request, const char* str) const override
    {
        return ioctl(fd, request, str);
    }
};

}}}
