// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <string>

namespace Azure { namespace Device { namespace Health { namespace Plugin {

enum CpuProcessState
{
    CPU_PROCESS_STATE_USER,
    CPU_PROCESS_STATE_SYSTEM,
    CPU_PROCESS_STATE_CHILD_USER,
    CPU_PROCESS_STATE_CHILD_SYSTEM,
    CPU_PROCESS_STATE_START_TIME,
    NUM_VALUES
};

struct CpuProcessInfo
{
    uint32_t ProcessId = 0;
    std::string ProcessName;
    std::string CommandLine;
    long long Sample[static_cast<uint32_t>(CpuProcessState::NUM_VALUES)] = {};
};

struct PerProcessCpuSample
{
    std::vector<CpuProcessInfo> Processes;
};

}}}}
