// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>
#include <string>

namespace Azure { namespace Device { namespace Health { namespace Plugin {

enum MemProcessInfoEnum
{
    MEM_PROCESS_INFO_PEAK_VIRTUAL_KB,
    MEM_PROCESS_INFO_VIRTUAL_SIZE_KB,
    MEM_PROCESS_INFO_LOCK_SIZE_KB,
    MEM_PROCESS_INFO_PIN_SIZE_KB,
    MEM_PROCESS_INFO_PEAK_RESIDENT_KB,
    MEM_PROCESS_INFO_RESIDENT_SIZE_KB,
    MEM_PROCESS_INFO_RESIDENT_ANON_KB,
    MEM_PROCESS_INFO_RESIDENT_FILE_KB,
    MEM_PROCESS_INFO_RESIDENT_SHARE_KB,
    MEM_PROCESS_INFO_DATA_KB,
    MEM_PROCESS_INFO_STACK_KB,
    MEM_PROCESS_INFO_TEXT_KB,
    MEM_PROCESS_INFO_SHARED_LIBRARY_KB,
    MEM_PROCESS_INFO_PTE_SIZE_KB,
    MEM_PROCESS_INFO_PMD_SIZE_KB,
    MEM_PROCESS_INFO_VIRTUAL_SWAP_KB,
    NUM_VALUES
};

struct MemoryProcessInfo
{
    int ProcessId = 0;
    std::string ProcessName;
    long long Sample[MemProcessInfoEnum::NUM_VALUES] = {};
};

struct PerProcessMemorySample
{
    std::vector<MemoryProcessInfo> Processes;
};

}}}}
