// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>

namespace Azure { namespace Device { namespace Health { namespace Plugin {

enum CpuState
{
    CPU_STATE_USER,
    CPU_STATE_NICE,
    CPU_STATE_SYSTEM,
    CPU_STATE_IDLE,
    CPU_STATE_IOWAIT,
    CPU_STATE_IRQ,
    CPU_STATE_SOFTIRQ,
    CPU_STATE_STEAL,
    CPU_STATE_GUEST,
    CPU_STATE_GUEST_NICE,
    NUM_VALUES
};

class CpuInfo
{
  public:
    uint64_t Sample[CpuState::NUM_VALUES] = {};
    uint64_t ContextSwitches = 0;
};

struct TotalCpuSample
{
    CpuInfo Total;
};

}}}}
