// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>

namespace Azure { namespace Device { namespace Health { namespace Plugin {

enum DiskStats
{
    MAJOR_NUMBER,
    MINOR_NUMBER,
    DEVICE_NAME,
    READS_COMPLETED,
    READS_MERGED,
    SECTORS_READ,
    MS_SPENT_READING,
    WRITES_COMPLETED,
    WRITES_MERGED,
    SECTORS_WRITTEN,
    MS_SPENT_WRITING,
    IOS_IN_PROGRESS,
    MS_SPENT_DOING_IO,
    WEIGHTED_NUM_OF_MS_DOING_IO,
    DISCARDS_COMPLETED,
    DISCARDS_MERGED,
    SECTORS_DISCARDED,
    MS_SPENT_DISCARDING,
    NUM_VALUES
};

struct DiskIoInfo
{
    uint64_t Sample[static_cast<uint32_t>(DiskStats::NUM_VALUES)] = {};
    std::string DeviceName;
};

struct TotalDiskIoSample
{
    std::vector<DiskIoInfo> Disks;
};

}}}}
