// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>

namespace Azure { namespace Device { namespace Health { namespace Plugin {

enum MemInfoState
{
    MEMINFO_TOTAL_KB,
    MEMINFO_FREE_KB,
    MEMINFO_BUFFERS_KB,
    MEMINFO_CACHED_KB,
    MEMINFO_SWAPCACHED_KB,
    MEMINFO_ACTIVE_KB,
    MEMINFO_INACTIVE_KB,
    MEMINFO_HIGH_TOTAL_KB,
    MEMINFO_HIGH_FREE_KB,
    MEMINFO_LOW_TOTAL_KB,
    MEMINFO_LOW_FREE_KB,
    MEMINFO_SWAP_TOTAL_KB,
    MEMINFO_SWAP_FREE_KB,
    MEMINFO_DIRTY_KB,
    MEMINFO_WRITEBACK_KB,
    MEMINFO_ANON_PAGES_KB,
    MEMINFO_MAPPED_KB,
    MEMINFO_SHARED_MEMORY_KB,
    MEMINFO_COMMIT_LIMIT_KB,
    MEMINFO_COMMITED_AS_KB,
    MEMINFO_VMALLOC_TOTAL_KB,
    NUM_VALUES
};

class TotalMemorySample
{
  public:
    uint64_t Sample[MemInfoState::NUM_VALUES];
};

}}}}
