// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <memory>
#include <stdint.h>
#include <string>

namespace Azure { namespace Device { namespace Health { namespace PluginUtils {

struct ProcessProperties
{
    std::string PackageName;
    std::string PackageVersion;
    std::string PackageArch;
    std::string SystemdCGroupPath;
    std::string DockerInstanceId;
    std::string DockerImageName;
    std::string DockerImageId;
};

class IProcessMetadataCache
{
  public:
    static std::unique_ptr<IProcessMetadataCache> Create();

  public:
    virtual ~IProcessMetadataCache() {}

    virtual std::shared_ptr<const ProcessProperties>
    GetProcessPropertiesByPid(uint32_t processId) = 0;
};

}}}}
