// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <map>
#include <string>
#include <vector>

#include <nonstd/span.hpp>

namespace Azure { namespace Device { namespace Health { namespace PluginUtils {

struct UdevDeviceEntry
{
    std::string SysName;
    std::map<std::string, std::string, std::less<>> Attributes;
};

std::vector<UdevDeviceEntry> EnumerateDeviceAttributes(
    const char* subsystemName,
    const char* sysNamePattern,
    nonstd::span<const char* const> attributeNames);

}}}}
