// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <azure-device-health-plugin-utils/IProcessMetadataCache.h>
#include <azure-device-util/LruCache.h>
#include <nlohmann/json.hpp>

namespace Azure { namespace Device { namespace Health { namespace PluginUtils {

class ProcessMetadataCache : public IProcessMetadataCache
{
  public:
    std::shared_ptr<const ProcessProperties>
    GetProcessPropertiesByPid(uint32_t processId) override;

  private:
    static std::string LookupSystemdCGroupPath(uint32_t processId);

    struct DockerProperties
    {
        std::string ImageName;
        std::string ImageId;
    };
    static DockerProperties
    LookupDockerProperties(std::string_view dockerObjectId);

  private:
    Utils::LruCache<uint32_t, ProcessProperties> _processLru;
};

}}}}
