// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <atomic>

#include "IPolicyManager.h"

namespace Azure { namespace Device { namespace Policy {

class LocalPolicyManager : public IPolicyManager
{
  public:
    void Update() override;

    Utils::TelemetryPermission GetTelemetryPermission() const override
    {
        return _telemetryPermission;
    }

  private:
    std::atomic<Utils::TelemetryPermission> _telemetryPermission =
        Utils::TelemetryPermission::Required;
};

}}}
