// Copyright (c) Microsoft Corporation. All rights reserved.

#include "LocalPolicyManager.h"

#include <iostream>

#include <azure-device-util/Permission.h>

namespace Azure { namespace Device { namespace Policy {

void LocalPolicyManager::Update()
{
    try
    {
        _telemetryPermission = Utils::Permission::ReadPermissionFromDefaultFile();
    }
    catch (const std::exception& e)
    {
        std::cout
            << "Failed to parse TelemetryPermission from default conf file: "
            << e.what() << std::endl;
    }

    std::string_view telPermissionString =
        Utils::Permission::ConvertTelemetryPermissionToString(
            _telemetryPermission);

    std::cout << "Using TelemetryPermission: " << telPermissionString
              << std::endl;
}

}}}
