// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <string>
#include <vector>

namespace Azure { namespace Device { namespace Telemetry {

//
// This class is the 'constant' view of AsimovEventBuffer.  Once a
// AsimovEventBuffer is done being modified, it is Commit()'d to produce this
// object.  It holds the data in the deflated format to take up less space. This
// is also the format expected by the server
//.
struct AsimovConstantEventBuffer
{
    const std::string Utf8ApiKeyHeader;
    const std::vector<std::byte> CompressedUtf8Json;
    const uint32_t NumberOfEvents;
};

}}}
