// Copyright (c) Microsoft Corporation. All rights reserved.

#include "AsimovEvent.h"
#include "CommonDefs.h"
#include "PrivacyTags.h"

namespace Azure { namespace Device { namespace Telemetry {

class AsimovSyntheticEvent : public AsimovEvent
{
  public:
    AsimovSyntheticEvent(
        std::string_view eventName,
        TriggerPersistence persistence = TriggerPersistence::Normal,
        TriggerLatency latency = TriggerLatency::Normal,
        TelemetryPermission minTelemetryPermission = TelemetryPermission::Optional,
        PrivacyTags tags = PrivacyTags_ProductAndServicePerformance,
        TriggerTelemetryCategory category = TriggerTelemetryCategory::Measures);

    template<class DataType>
    void AddPartCField(std::string_view eventName, const DataType& data)
    {
        _jsonBuilder.push_back(_partCItr, eventName, data);
    }

  private:
    jsonbuilder::JsonIterator _partCItr;
};

}}}
