// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>
#include <memory>

#include "IEventSerializer.h"

namespace Azure { namespace Device { namespace Telemetry {

class IEventConsumer
{
  public:
    virtual ~IEventConsumer() = default;

    virtual void StartConsuming() = 0;

    virtual void ReloadConfiguration() = 0;

    // Needs to be thread safe
    virtual void StopConsuming() = 0;
    virtual void WaitForCompletion() = 0;
};

}}}