// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <azure-device-util/Permission.h>

namespace Azure { namespace Device { namespace Telemetry {

struct TelemetrySettingOverrides
{
    std::optional<double> SampleRate;

    // In the future, can include things like Latency/Peristence, or even a
    // permission swap here, each as optionals.

    void MergeSettingsOverrides(const TelemetrySettingOverrides& higherPri)
    {
        if (higherPri.SampleRate)
        {
            SampleRate = higherPri.SampleRate;
        }
    }
};

class ITelemetrySettings
{
  public:
    virtual ~ITelemetrySettings() = default;

    virtual TelemetrySettingOverrides GetTelemetryEventSettings(
        Azure::Device::Utils::TelemetryPermission permissionLevel,
        std::string_view providerName,
        std::string_view eventName) = 0;
};

}}}
