// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <memory>
#include <mutex>
#include <string>
#include <vector>

#include "CommonDefs.h"

namespace Azure { namespace Device { namespace Telemetry {

enum class UploadResult : int8_t
{
    Succeeded,
    Failed,
    Preempted
};

struct UploadWorkDefinition
{
    explicit UploadWorkDefinition(TriggerLatency l) : Latency(l) {}

    TriggerLatency Latency;

    bool operator<(const UploadWorkDefinition& other) const
    {
        return Latency < other.Latency;
    }
};

class IUploadScheduler
{
  public:
    virtual ~IUploadScheduler() {}
    virtual void StartTimers() = 0;
    virtual void EndTimers() = 0;
    virtual void ArmTimer(TriggerLatency latency) = 0;
};

}}}