/*++

    Copyright (c) Microsoft Corporation.
    Licensed under the MIT License.

Abstract:

    NGP Privacy Tags for Diagnostic Data emitted through CLOG

    Note that this is the set of valid privacy tags for Diagnostic Data as
    defined by the NGP workflows from Windows Privacy. These values are locked
to the values used by the Windows OS and cannot be changed or added to. Other
    diagnostic data tags are not considered valid for Windows Diagnostic Data.

--*/

#pragma once

#include <cstdint>

enum PrivacyTags : uint64_t
{
    PrivacyTags_BrowsingHistory = 0x0000000000000002ULL,
    PrivacyTags_DeviceConnectivityAndConfiguration = 0x0000000000000800ULL,
    PrivacyTags_InkingTypingAndSpeechUtterance = 0x0000000000020000ULL,
    PrivacyTags_ProductAndServicePerformance = 0x0000000001000000ULL,
    PrivacyTags_ProductAndServiceUsage = 0x0000000002000000ULL,
    PrivacyTags_SoftwareSetupAndInventory = 0x0000000080000000ULL
};