// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <system_error>

namespace Azure { namespace Device { namespace Telemetry {

enum class TelemetryError
{
    E_NETWORK_BACKOFF_IN_PROGRESS = 1,
    E_DB_SCHEMA_CHANGED = 100,
    E_DB_CANNOT_SHRINK = 101,
    E_DB_INTEGRITY_CHECK_FAIL = 102,
    E_EVENT_RULE_TOO_LONG = 200,
    E_ILLEGAL_DOT_NET_EVENT_SOURCE_EVENT = 201,
};

std::error_code make_error_code(TelemetryError error);
std::error_code make_lttng_error_code(int lttngError);

}}}

namespace std {
template<>
class is_error_code_enum<Azure::Device::Telemetry::TelemetryError>
    : public std::true_type
{};
}
