// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <chrono>

namespace Azure { namespace Device { namespace Telemetry {

class ITimeService
{
  public:
    virtual ~ITimeService() {}
    virtual std::chrono::steady_clock::time_point SteadyNow() = 0;
    virtual std::chrono::system_clock::time_point SystemNow() = 0;
};

class TimeService : public ITimeService
{
  public:
    std::chrono::steady_clock::time_point SteadyNow() override
    {
        return std::chrono::steady_clock::now();
    }

    std::chrono::system_clock::time_point SystemNow() override
    {
        return std::chrono::system_clock::now();
    }
};

}}}