// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <string>
#include <optional>

#include <jsonbuilder/JsonBuilder.h>

#include "AsimovEvent.h"
#include "JournalDConsumerConfig.hpp"
#include "DynamicParser.hpp"
#include "IEventSerializer.h"
#include "MessageEvent.hpp"
#include "StaticParser.hpp"

using EventTelemetryLevels = std::map<std::string, int>;

namespace Azure { namespace Device { namespace Telemetry {

class Router
{
  public:
    Router(IEventSerializer& serializer, JournalDConsumerConfig& consumerConfig);

    void RouteMessageEvent(const MessageEvent& event);

  private:
    std::optional<jsonbuilder::JsonBuilder>
    GetEventJsonBuilder(const MessageEvent& event);

    IEventSerializer& _serializer;
    JournalDConsumerConfig& _consumerConfig;
    StaticParser _staticParser;
    DynamicParser _dynParser;
};

}}}
