// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <filesystem>
#include <functional>

#include "LttngSession.h"

namespace Azure { namespace Device { namespace Telemetry {

class EventConfigurationParser
{
    using ConfFileParseCallback =
        std::function<void(std::string_view, ListeningRuleSet&&)>;

  public:
    EventConfigurationParser(std::string_view confFolder);

    void Parse(const ConfFileParseCallback& onFileParseCallback);

  private:
    void ParseFile(
        const ConfFileParseCallback& onFileParseCallback,
        const std::filesystem::path& fullPath);

  private:
    std::string _confFolder;
};

}}}
