// Copyright (c) Microsoft Corporation. All rights reserved.

#include "LttngError.h"

namespace Azure { namespace Device { namespace Telemetry {

class LttngErrorCat : public std::error_category
{
    const char* name() const noexcept override { return "LttngErrorCat"; }
    std::string message(int e) const override
    {
        return "LttngError: " + std::to_string(e);
    }
};

LttngErrorCat c_lttngErrorCat;

std::error_code make_lttng_error_code(int lttngError)
{
    return { lttngError, c_lttngErrorCat };
}

}}}