// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <vector>
#include <optional>

#include "StaticParserRule.hpp"

namespace Azure { namespace Device { namespace Telemetry {

using StaticParserRuleSet = std::vector<StaticParserRule>;

class StaticParser
{
  public:
    StaticParser(const StaticParserRuleSet& staticRules);
    std::optional<jsonbuilder::JsonBuilder> ParseEvent(const MessageEvent& event);

  private:
    const StaticParserRuleSet& _rules;
};

}}}
