// Copyright (c) Microsoft Corporation. All rights reserved.

#include "TelemetryError.h"

namespace Azure { namespace Device { namespace Telemetry {

class TelemetryErrorCat : public std::error_category
{
    const char* name() const noexcept override { return "TelemetryErrorCat"; }
    std::string message(int e) const override
    {
        return "TelemetryError: " + std::to_string(e);
    }
};

TelemetryErrorCat c_telemetryErrorCat;

std::error_code make_error_code(TelemetryError error)
{
    return { static_cast<int>(error), c_telemetryErrorCat };
}

}}}
