// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <optional>
#include <string>
#include <vector>

#include "SettingsDataTypes.h"

namespace Azure { namespace Device { namespace Utils {
class IConfig;
class ConfigPath;
}}}

namespace Azure { namespace Device { namespace Telemetry {

class SettingsConfigReader
{
  public:
    std::vector<SettingsNamespaceConfig>
    LoadSettingsFromIConfig(Utils::IConfig& config);

  private:
    static std::optional<SettingsNamespaceConfig> ParseSettingsNamespace(
        Utils::IConfig& config,
        const Utils::ConfigPath& elementPath);

    static void LogBrokenSettingsNamespace(
        const Utils::ConfigPath& elementPath,
        const std::vector<std::string>& brokenFields);

    static void LogSuccessfullyParsedSettingsNamespace(
        const SettingsNamespaceConfig& settingsNamespace);
};

}}}
