// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <optional>
#include <string>

#include "SettingsDataTypes.h"

namespace Azure { namespace Device { namespace Telemetry {

class SettingsNamespaceContentSerializer
{
  public:
    std::string ToJsonString(const SettingsNamespaceContent& content);

    std::optional<SettingsNamespaceContent>
    FromJsonString(std::string_view contentJson);
};

class SettingsNamespaceMetadataSerializer
{
  public:
    std::string ToJsonString(const SettingsNamespaceMetadata& metadata);

    std::optional<SettingsNamespaceMetadata>
    FromJsonString(std::string_view metadataJson);
};

}}}
