// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <memory>
#include <string_view>

#include "AsimovEventBuffer.h"
#include "HeartBeat.h"
#include "IEventSerializer.h"
#include "IEventStore.h"

namespace Azure { namespace Device { namespace Telemetry {

// Defines Interface of EventStore Type
class EventStoreFactory
{
  public:
#ifdef AZURE_DEVICE_TELEMETRY_USE_STORAGE_SQLITE
    static std::unique_ptr<IEventStore> CreateSqliteEventStore(
        HeartBeat& heartBeat,
        IEventSerializer& serializer,
        IAsimovEventBufferFactory& asimovEventBufferFactory,
        std::string_view databaseDirectory,
        uint32_t maxSizeInBytes,
        uint32_t preCompressBufferNormalEventCount,
        uint32_t preCompressBufferCriticalEventCount,
        uint32_t preCompressBufferByteLimit);
#endif
};

}}}
