// Copyright (c) Microsoft Corporation. All rights reserved.

#include "UploaderFactory.h"

#include "TelemetryError.h"
#include "azure-device-util/ResultException.h"

#ifdef AZURE_DEVICE_TELEMETRY_USE_UPLOADER_HTTP
    #include "http/AsimovUploadQueue.h"
#endif

namespace Azure { namespace Device { namespace Telemetry {

#ifdef AZURE_DEVICE_TELEMETRY_USE_UPLOADER_HTTP
std::unique_ptr<IUploadScheduler> UploaderFactory::CreateHttpUploader(
    std::string_view uploadUrl,
    IHeartBeat& heartBeat,
    IEventSerializer& serializer,
    IEventStore& eventStore,
    IHttpSessionManager& httpSessionManager,
    IAsimovUploadWorkItemFactory& uploadWorkItemFactory)
{
    return std::make_unique<AsimovUploadQueue>(
        uploadUrl,
        heartBeat,
        serializer,
        eventStore,
        httpSessionManager,
        uploadWorkItemFactory);
}
#endif

}}}