// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <memory>
#include <string_view>

#include "IUploadScheduler.h"

namespace Azure { namespace Device { namespace Telemetry {

class IHeartBeat;
class IEventSerializer;
class IEventStore;
class IHttpSessionManager;
class IAsimovUploadWorkItemFactory;

class UploaderFactory
{
  public:
#ifdef AZURE_DEVICE_TELEMETRY_USE_UPLOADER_HTTP
    static std::unique_ptr<IUploadScheduler> CreateHttpUploader(
        std::string_view uploadUrl,
        IHeartBeat& heartBeat,
        IEventSerializer& serializer,
        IEventStore& eventStore,
        IHttpSessionManager& httpSessionManager,
        IAsimovUploadWorkItemFactory& uploadWorkItemFactory);
#endif
};

}}}
