#pragma once

#include <cstdio>

//
// This header is temporary to allow us to log to LogCat directly from our
// Android code. The goal is to replace this with a TraceLogging implementation
// to LogCat in the future. It will turn a no-op on non-Android
//

#ifdef ANDROID
    #include <android/log.h>
    #define ADHS_LOG(...) \
        __android_log_print(ANDROID_LOG_INFO, LOG_TAG, __VA_ARGS__);
#else

// This is needed to avoid unused-parameter and unused-variable errors on
// non-Android platforms
inline static void _doNothing(...) {}
    #define ADHS_LOG(formatString, ...) _doNothing(__VA_ARGS__);
#endif