// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <cstdint>

namespace Azure { namespace Device { namespace ConversionFactors {

static const uint64_t filetimeToNanoseconds = 100uLL;
static const uint64_t millisecondsToFiletime = 10000uLL;
static const uint64_t secondsToFiletime = 1000 * millisecondsToFiletime;
static const uint64_t minutesToFiletime = 60 * secondsToFiletime;
static const uint64_t hoursToFiletime = 60 * minutesToFiletime;
static const uint64_t daysToFiletime = 24 * hoursToFiletime;
static const uint64_t unixEpochToFiletimeEpoch = 116444736000000000ULL;

static const uint32_t secondsToMilliseconds = 1000;
static const uint32_t minutesToMilliseconds = 60 * secondsToMilliseconds;
static const uint32_t hoursToMilliseconds = 60 * minutesToMilliseconds;
static const uint32_t daysToMilliseconds = 24 * hoursToMilliseconds;

static const uint32_t minutesToSeconds = 60;
static const uint32_t hoursToMinutes = 60;
static const uint32_t hoursToSeconds = hoursToMinutes * minutesToSeconds;
static const uint32_t daysToMinutes = 24 * hoursToMinutes;

static const uint32_t kbToBytes = 1024;
static const uint32_t mbToBytes = 1024 * kbToBytes;
static const uint64_t gbToBytes = 1024 * mbToBytes;

}}}
