// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <system_error>

// clang-format off
#define SUCCEEDED(hr) (!(hr))
#define FAILED(hr) (!!(hr))

namespace Azure { namespace Device { namespace Utils {

enum class UtilsError
{
    E_STD_EXCEPTION = 1,
    E_INVALID_PERMISSION_VALUE = 2
};

std::error_code make_error_code(UtilsError error);

}}}

namespace std
{
    template <>
    class is_error_code_enum<Azure::Device::Utils::UtilsError> : public true_type {};
}

std::error_code make_zlib_error_code(int zlibError);
