// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <iomanip>
#include <sstream>
#include <string>
#include <string_view>

#include <azure-device-util/ResultException.h>

#ifdef AZURE_DEVICE_UTILS_USE_SYSTEMD_BASED_IDENTITY
    #include <systemd/sd-id128.h>
#endif

namespace Azure { namespace Device { namespace Utils {

using namespace std::string_view_literals;

class Identity
{
  public:
    static constexpr std::string_view c_localIdPrefix = "s:"sv;

    static std::string GetMachineBasedDeviceId(bool prefix = true);
};
}}}
