// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <optional>
#include <string_view>
#include <system_error>

namespace Azure { namespace Device { namespace Utils {

enum class TelemetryPermission
{
    None = 0,
    Required = 1,
    Optional = 3
};

class Permission
{
  public:
    static TelemetryPermission ReadPermissionFromDefaultFile();

    static std::error_code
    WritePermissionToDefaultFile(TelemetryPermission permission);

    static TelemetryPermission
    ConvertStringToTelemetryPermission(std::string_view permissionString);

    static std::optional<TelemetryPermission>
    TryConvertStringToTelemetryPermission(std::string_view permissionString);

    static std::string_view
    ConvertTelemetryPermissionToString(TelemetryPermission permission);
};

}}}
