// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <dlfcn.h>
#include <memory>

namespace Azure { namespace Device { namespace Utils {

struct dl_module_close
{
    void operator()(void* module)
    {
        if (module != nullptr)
        {
            dlclose(module);
        }
    }
};
using unique_dl_module = std::unique_ptr<void, dl_module_close>;

}}}
