// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <functional>
#include <initializer_list>
#include <map>
#include <signal.h>

namespace Azure { namespace Device { namespace Utils {

class SignalLoop
{
  public:
    using SignalHandler = std::function<bool(int)>;

    SignalLoop(std::initializer_list<int> signals);

    void RegisterSignalHandler(int signal, SignalHandler&& handler);

    void Run();

  private:
    std::map<int, SignalHandler> _signalToHandler;
    sigset_t _signals;
};
}}}
